#include <sys/time.h>
#include <strings.h>
#include <string.h>
#include <stdio.h>
#include <gtk/gtk.h>

#include "lopster.h"
#include "support.h"
#include "md5.h"
#include "connection.h"
#include "commands.h"
#include "interface.h"
#include "callbacks.h"
#include "scheme.h"
#include "handler.h"
#include "log.h"
#include "global.h"
#include "chat.h"
#include "search.h"
#include "share.h"
#include "transfer.h"
#include "hotlist.h"
#include "resume.h"
#include "server.h"
#include "dialog.h"
#include "preferences.h"

int get_color(char chr) {
  switch (chr) {
  case 'r': return 4;
  case 'b': return 2;
  case 'g': return 3;
  case 'c': return 10;
  case 'y': return 8;
  case 'Y': return 5;
  case 'k': return 1;
  default: return -1;
  }
} 

void text_print_text(GtkText* widget, char* fmt, ...) {
  char* pos;
  char text2[2048];
  char* text;
  GdkColor* color = NULL;
  int temp;
  va_list ap;

  va_start (ap, fmt);
  vsprintf (text2, fmt, ap);
  va_end (ap);

  text = text2;
  while ((pos = strchr(text, '$')) != NULL) {
    gtk_text_insert(widget, NULL, color, NULL, text, pos-text);
    text = pos;
    temp = get_color(pos[1]);
    if (temp >= 0) {
      color = &global.color_table[temp];
      text += 2;
    } else {
      gtk_text_insert(widget, NULL, color, NULL, text, 1);
      text++;
    }
  }
  gtk_text_insert(widget, NULL, color, NULL, text, strlen(text));
}

void port_dialog(char* message) {
  GtkWidget* win;
  GtkText* text;

  win = create_information_win();
  gtk_widget_show(win);
  gtk_window_set_title(GTK_WINDOW(win), _("Bind Error"));
  text = GTK_TEXT(lookup_widget(win, "text15"));
  gtk_text_set_word_wrap(text, 1);
  
  text_print_text(text, _("$r-------------------------\n Information\n-------------------------\n\n"));
  text_print_text(text, _("$kCould not set up data port: $b%s.\n"), message);
  text_print_text(text, _("$kMaybe other programs use theses ports.\n"));
  text_print_text(text, _("$kAt the moment the data port was set to $b0$k, so you cannot download from users who set their port also to 0.\n"));
  text_print_text(text, _("$kIf you do not want this, choose another port at $bPreferences->General->Port for Uploading Files $k and deactivate the $bFirewall $kbutton.\n"));
}

/*
void download_dialog(char* filename, int mime) {
  GtkWidget* win;
  GtkText* text;
  
  win = create_information_win();
  gtk_widget_show(win);
  gtk_window_set_title(GTK_WINDOW(win), _("Information"));
  text = GTK_TEXT(lookup_widget(win, "text15"));
  gtk_text_set_word_wrap(text, 1);
  
  text_print_text(text, _("$r-------------------------\n Warning\n-------------------------\n\n"));
  text_print_text(text, _("$kDownload of file $b%s $kfailed.\n"), filename);
  text_print_text(text, _("$kEither the $bincomplete $kpath was not set or\n"));
  text_print_text(text, _("$kno valid $b path $kwas specified for mime type $b%s\n"), MimeNames(mime));
  text_print_text(text, _("$kPlease select a valid directory in $bNapster->Preferences->Paths->Download$k!\n"));
}
*/

void changes_dialog(char* title) {
  GtkWidget* win;
  GtkText* text;
  
  win = create_information_win();
  gtk_window_set_title(GTK_WINDOW(win), title);
  text = GTK_TEXT(lookup_widget(win, "text15"));
  gtk_text_set_word_wrap(text, 1);
  
  text_print_text(text, _("$r-------------------------\nChanges since version 0.9.8\n-------------------------\n\n"));
  
  text_print_text(text, _("$cA lot of changes, nothing interesting.:)\n\n"));
  /*
  text_print_text(text, _("$r* $kFirst of all: If you are upgrading from an older version check your preferences again! A few settings may now be messed, in particular the transfer settings.\n\n"));
  text_print_text(text, _("$r* $kCheck out $bHelp->News$k from time to time. If any problem appears in version 0.9.8 it will be shown there.\n\n"));
  text_print_text(text, _("$r* $kTry right clicking on a username in the chat window.\n\n"));
  text_print_text(text, _("$r* $kA lot of pages are now detachable.\n\n"));
  text_print_text(text, _("$r* $kYou are now able to connect to a server from the napigator list directly without adding it to the selected server list.\n\n"));
  text_print_text(text, _("$r* $kThe highlighted text strings are no longer quote separated but space separated.\n\n"));
  text_print_text(text, _("$r* $kThe Chat output has changed a bit. You are now able to specify a server and a client prefix in $bPreferences->Schemes $k(uses same color codes as in chat line).\n\n"));
  text_print_text(text, _("$r* $kThe Library is no longer autosaved but you can save it manually to a specific file and load it again.\n\n"));
  text_print_text(text, _("$r* $kThe Resume window has moved to the search page. Also there is the ability to search in search results.\n\n"));
  text_print_text(text, _("$r* $kYou can limit the upload and the download bandwidth\n\n"));
  text_print_text(text, _("$r* $kYou can now specify which transfers should be automatically retried, removed from transfer tab or deleted from incomplete list\n\n"));
  text_print_text(text, _("$r* $kNative language support added.\n\n"));
  */
  text_print_text(text, _("$rHave Fun!!!  Sgop\n"));
  gtk_my_widget_show(win);
}

GtkWidget*
create_info_win (char* text, char** buttons, GtkSignalFunc* func)
{
  GtkWidget *delete_win;
  GtkWidget *frame172;
  GtkWidget *vbox;
  GtkWidget *vbox1;
  GtkWidget *hbox263;
  GtkWidget *frame214;
  GtkWidget *pixmap30;
  GtkWidget *label435;
  GtkWidget *hseparator24;
  GtkWidget *frame173;
  GtkWidget *hbox262;
  GtkWidget *button170;
  int i1;

  delete_win = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (delete_win), _("Information"));
  gtk_window_set_policy (GTK_WINDOW (delete_win), FALSE, FALSE, FALSE);

  frame172 = gtk_frame_new (NULL);
  gtk_widget_show (frame172);
  gtk_container_add (GTK_CONTAINER (delete_win), frame172);
  gtk_container_set_border_width (GTK_CONTAINER (frame172), 5);

  vbox = gtk_vbox_new (FALSE, 5);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (frame172), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

  hbox263 = gtk_hbox_new (FALSE, 10);
  gtk_widget_show (hbox263);
  gtk_box_pack_start (GTK_BOX (vbox), hbox263, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox263), 12);

  vbox1 = gtk_vbox_new (FALSE, 5);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox263), vbox1, FALSE, FALSE, 0);

  frame214 = gtk_frame_new (NULL);
  gtk_widget_show (frame214);
  gtk_box_pack_start (GTK_BOX (vbox1), frame214, FALSE, FALSE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame214), GTK_SHADOW_IN);

  pixmap30 = create_pixmap (delete_win, "info.xpm");
  gtk_widget_show (pixmap30);
  gtk_container_add (GTK_CONTAINER (frame214), pixmap30);

  label435 = gtk_label_new(text);
  gtk_widget_show (label435);
  gtk_box_pack_start (GTK_BOX (hbox263), label435, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label435), GTK_JUSTIFY_LEFT);

  hseparator24 = gtk_hseparator_new ();
  gtk_widget_show (hseparator24);
  gtk_box_pack_start (GTK_BOX (vbox), hseparator24, FALSE, FALSE, 0);

  frame173 = gtk_frame_new (NULL);
  gtk_widget_show (frame173);
  gtk_box_pack_start (GTK_BOX (vbox), frame173, FALSE, FALSE, 0);
  gtk_widget_set_usize (frame173, -2, 41);
  gtk_frame_set_shadow_type (GTK_FRAME (frame173), GTK_SHADOW_IN);

  hbox262 = gtk_hbox_new (TRUE, 5);
  gtk_widget_show (hbox262);
  gtk_container_add (GTK_CONTAINER (frame173), hbox262);
  gtk_container_set_border_width (GTK_CONTAINER (hbox262), 5);

  gtk_signal_connect (GTK_OBJECT (delete_win), "destroy",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      delete_win);

  i1 = 0;
  while (buttons[i1]) {
    button170 = gtk_button_new_with_label (buttons[i1]);
    gtk_widget_show (button170);
    gtk_box_pack_start (GTK_BOX (hbox262), button170, TRUE, TRUE, 0);
    gtk_signal_connect (GTK_OBJECT (button170), "clicked",
			func[i1], delete_win);
    i1++;
  }  
  return delete_win;
}

void
on_close_clicked                     (GtkButton       *button,
				      gpointer         user_data) {
  gtk_widget_destroy(GTK_WIDGET(user_data));
}

void
on_open_pref_clicked                     (GtkButton       *button,
					gpointer         user_data) {
  gtk_widget_destroy(GTK_WIDGET(user_data));
  preferences_goto(3);
}

void openfile_dialog(char* text) {
  GtkSignalFunc func[3];
  char* buttons[3];
  GtkWidget* temp;

  func[0] = (GtkSignalFunc)on_close_clicked;
  func[1] = (GtkSignalFunc)on_open_pref_clicked;
  func[2] = NULL;
  buttons[0] = strdup(_("Close"));
  buttons[1] = strdup(_("Setup Applications"));
  buttons[2] = NULL;
  
  temp = create_info_win(text, buttons, func);
  gtk_widget_show(temp);
  
  g_free(buttons[0]);
  g_free(buttons[1]);
}

void
on_download1_pref_clicked                     (GtkButton       *button,
					      gpointer         user_data) {
  gtk_widget_destroy(GTK_WIDGET(user_data));
  preferences_goto(4);
}
void
on_download2_pref_clicked                     (GtkButton       *button,
					      gpointer         user_data) {
  gtk_widget_destroy(GTK_WIDGET(user_data));
  preferences_goto(5);
}

void download_dialog(char* filename, int mime) {
  GtkSignalFunc func[4];
  char* buttons[4];
  GtkWidget* temp;
  char* text;

  text = g_strdup_printf(_("Download of file %s failed.\nEither the incomplete path was not set or\nno valid path was specified for mime type %s.\n"),
			 filename, MimeNames(mime));
  func[0] = (GtkSignalFunc)on_close_clicked;
  func[1] = (GtkSignalFunc)on_download1_pref_clicked;
  func[2] = (GtkSignalFunc)on_download2_pref_clicked;
  func[3] = NULL;
  buttons[0] = strdup(_("Close"));
  buttons[1] = strdup(_("Set incomplete path"));
  buttons[2] = strdup(_("Set download path"));
  buttons[3] = NULL;
  
  temp = create_info_win(text, buttons, func);
  gtk_widget_show(temp);
  
  g_free(buttons[0]);
  g_free(buttons[1]);
  g_free(buttons[2]);
}

void
on_delete_selected1_activate(GtkMenuItem     *menuitem,
			    gpointer         user_data)
{
  GtkCList* clist;
  int row;
  socket_t* socket;
  GList* dlist;
  GList* result = NULL;

  clist = GTK_CLIST(global.popup_list);

  for (dlist = clist->selection; dlist; dlist = dlist->next) {
    row = (int)dlist->data;
    socket = (socket_t*)gtk_clist_get_row_data(clist, row);
    result = g_list_append(result, socket);
  }

  for (dlist = result; dlist; dlist = dlist->next) {
    socket = (socket_t*)(dlist->data);
    row = gtk_clist_find_row_from_data(clist, socket);
    if (row >= 0) socket_end(socket, &(SocketStatus[S_DELETE]));
  }
  if (result) g_list_free(result);

  if (user_data) gtk_widget_destroy(GTK_WIDGET(user_data));
}

void delete_dialog(char* text) {
  GtkSignalFunc func[4];
  char* buttons[4];
  GtkWidget* temp;

  if (global.options.confirm_delete) {
    func[0] = (GtkSignalFunc)on_delete_selected1_activate;
    func[1] = (GtkSignalFunc)on_close_clicked;
    func[2] = NULL;
    buttons[0] = strdup(_("Do it!"));
    buttons[1] = strdup(_("Cancel"));
    buttons[2] = NULL;
    
    temp = create_info_win(text, buttons, func);
    gtk_widget_show(temp);
    
    g_free(buttons[0]);
    g_free(buttons[1]);
  } else {
    on_delete_selected1_activate(NULL, NULL);
  }
}

void
on_delete_selected2_activate(GtkMenuItem     *menuitem,
			      gpointer         user_data)
{
  GtkCTree* ctree;
  GList* row_list;
  GtkCTreeNode* node;
  resume_t* resume;

  ctree = GTK_CTREE(global.popup_list);

  while ((row_list = GTK_CLIST(ctree)->selection) != NULL) {
    node = GTK_CTREE_NODE(row_list->data);
    if (GTK_CTREE_ROW(node)->parent == NULL) {
      resume = (resume_t*)gtk_ctree_node_get_row_data(ctree, node);
      resume_list_remove(resume, NULL);
    }
  }
  if (user_data) gtk_widget_destroy(GTK_WIDGET(user_data));
}

void resume_delete_dialog(char* text) {
  GtkSignalFunc func[4];
  char* buttons[4];
  GtkWidget* temp;

  if (global.options.confirm_delete) {
    func[0] = (GtkSignalFunc)on_delete_selected2_activate;
    func[1] = (GtkSignalFunc)on_close_clicked;
    func[2] = NULL;
    buttons[0] = strdup(_("Do it!"));
    buttons[1] = strdup(_("Cancel"));
    buttons[2] = NULL;
    
    temp = create_info_win(text, buttons, func);
    gtk_widget_show(temp);
    
    g_free(buttons[0]);
    g_free(buttons[1]);
  } else {
    on_delete_selected2_activate(NULL, NULL);
  }
}

void
on_new_version_remember                     (GtkButton       *button,
					     gpointer         user_data) {
  gtk_widget_destroy(GTK_WIDGET(user_data));
  global.options.check_version = 1;
}

void
on_new_version_noticed                     (GtkButton       *button,
					    gpointer         user_data) {
  gtk_widget_destroy(GTK_WIDGET(user_data));
  global.options.check_version = 2;
}

void new_version_dialog(char* text) {
  GtkSignalFunc func[3];
  char* buttons[3];
  GtkWidget* temp;
  char* str;

  func[0] = (GtkSignalFunc)on_new_version_remember;
  func[1] = (GtkSignalFunc)on_new_version_noticed;
  func[2] = NULL;
  buttons[0] = strdup(_("Remember next time"));
  buttons[1] = strdup(_("Noticed!"));
  buttons[2] = NULL;
  
  str = g_strdup_printf(_("Lopster %s is available NOW!\nCheck out lopster.sourceforge.net!"),
			text);
  temp = create_info_win(str, buttons, func);
  gtk_widget_show(temp);
  g_free(str);

  g_free(buttons[0]);
  g_free(buttons[1]);
}

void
on_check_version_close                    (GtkButton       *button,
					   gpointer         user_data) {
  gtk_widget_destroy(GTK_WIDGET(user_data));
}

void check_version_dialog(char* text) {
  GtkSignalFunc func[2];
  char* buttons[2];
  GtkWidget* temp;
  char* str;

  func[0] = (GtkSignalFunc)on_check_version_close;
  func[1] = NULL;
  buttons[0] = strdup(_("Close"));
  buttons[1] = NULL;
  
  if (!version_is_up_to_date(text)) {
    str = g_strdup_printf(_("Latest release is %s\nYour version seems to be outdated!\n"),
			  text);
  } else {
    str = g_strdup_printf(_("Latest Lopster is %s\nYour version is up to date!\n"),
			  text);
  }
  temp = create_info_win(str, buttons, func);
  gtk_widget_show(temp);
  g_free(str);

  g_free(buttons[0]);
}
